<template>
  <div>

    <!-- TITLE SECTION -->

    <div class="section-title text-center py-3 py-md-5">
      Cadastro de usuário
    </div>

    <!-- USP BOND SECTION -->

    <b-form v-if="show" @submit="onSubmit">
      <b-card class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Vínculo com a USP
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações sobre o vínculo do usuário com a USP
          </p>
        </div>
        <b-form-checkbox id="is_USP_user" v-model="form.is_USP_user" plain name="Membro USP" value="true" unchecked-value="false" class="w-100 mx-md-5">É membro USP</b-form-checkbox>
        <b-form-select v-model="form.workplace" :options="workplaces" class="my-3">
          <template slot="first">
            <!-- this slot appears above the options from 'options' prop -->
            <option :value="null" disabled>Local de Trabalho ou Pesquisa</option>
          </template>
        </b-form-select>
        <b-form-select v-model="form.USP_bond_options" :options="bond_options" class="my-3">
          <template slot="first">
            <!-- this slot appears above the options from 'options' prop -->
            <option :value="null" disabled>Tipo de vinculo com a USP</option>
          </template>
        </b-form-select>
      </b-card>

      <!-- User Identication Section -->

      <b-card class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Identificação do usuário
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações sobre o usuário
          </p>
        </div>
        <b-form-group id="nome-do-usuario"
                      label="Nome:"
                      label-for="nome do usuario">
          <b-form-input id="user_name"
                        v-model="form.user_name"
                        type="text"
                        required
                        placeholder="Nome Completo do Usuário ou Empresa"/>
        </b-form-group>
        <b-form-checkbox-group id="is_person" v-model="form.is_person" plain name="Pessoa Física">
          <b-form-checkbox checked class="w-100 mx-md-5">É pessoa física</b-form-checkbox>
        </b-form-checkbox-group>
      </b-card>
      <b-card v-if="form.is_person" class="my-3">
        <b-form-group id="cpf-do-usuario"
                      label="CPF:"
                      label-for="cpf do usuario">
          <b-form-input id="user_cpf"
                        v-model="form.user_CPF"
                        type="text"
                        optional
                        placeholder="CPF do usuário"/>
        </b-form-group>
        <b-form-group id="nascimento-do-usuario"
                      label="Data de Nascimento:"
                      label-for="data de nascimento">
          <b-form-input id="birth_date"
                        v-model="form.birth_date"
                        type="text"
                        optional
                        placeholder="XX/YY/ZZZZ"/>
        </b-form-group>
        <b-form-select v-model="form.gender" :options="gender_options" class="my-3">
          <template slot="first">
            <!-- this slot appears above the options from 'options' prop -->
            <option :value="null" disabled>Gênero</option>
          </template>
        </b-form-select>
        <b-form-group id="rg-do-usuario"
                      label="RG:"
                      label-for="Registro Geral">
          <b-form-input id="user_id"
                        v-model="form.user_id"
                        type="text"
                        optional
                        placeholder="RG do usuário"/>
        </b-form-group>
      </b-card>
      <b-card v-if="!form.is_person" class="my-3">
        <b-form-group id="cnpj-do-usuario"
                      label="CNPJ:"
                      label-for="CNPJ">
          <b-form-input id="company_id"
                        v-model="form.company_id"
                        type="text"
                        optional
                        placeholder="CNPJ da Empresa"/>
        </b-form-group>
        <b-form-group id="ie-do-usuario"
                      label="Inscrição Estadual:"
                      label-for="IE">
          <b-form-input id="company_ie"
                        v-model="form.company_ie"
                        type="text"
                        optional
                        placeholder="IE da Empresa"/>
        </b-form-group>
        <b-form-group id="im-do-usuario"
                      label="Inscrição Municipal:"
                      label-for="IM">
          <b-form-input id="company_im"
                        v-model="form.company_im"
                        type="text"
                        optional
                        placeholder="IM da Empresa"/>
        </b-form-group>
      </b-card>
      <b-card>
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Endereço
          </p>
        </div>
        <b-form-group id="cep-do-usuario"
                      label="CEP:"
                      label-for="CEP">
          <b-form-input id="user_CEP"
                        v-model="form.user_CEP"
                        type="text"
                        required
                        placeholder="CEP do usuário ou empresa"/>
        </b-form-group>
        <b-form-group id="rua-do-usuario"
                      label="Rua:"
                      label-for="rua">
          <b-form-input id="user_street"
                        v-model="address.street"
                        type="text"
                        required
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="numero-do-usuario"
                      label="Numero:"
                      label-for="numero">
          <b-form-input id="user_number"
                        v-model="address.number"
                        type="text"
                        required
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="cidade-do-usuario"
                      label="Cidade:"
                      label-for="cidade">
          <b-form-input id="user_city"
                        v-model="form.user_city"
                        type="text"
                        required
                        placeholder="Ex: São Paulo"/>
        </b-form-group>
        <b-form-select v-model="form.user_state" :options="states" class="my-3">
          <template slot="first">
            <!-- this slot appears above the options from 'options' prop -->
            <option :value="null" disabled>Estado</option>
          </template>
        </b-form-select>
        <b-form-group id="telefone-do-usuario"
                      label="Telefone:"
                      label-for="telefone">
          <b-form-input id="user_phone"
                        v-model="form.user_phone"
                        type="text"
                        required
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="telefone2-do-usuario"
                      label="Telefone 2:"
                      label-for="telefone2">
          <b-form-input id="user_phone2"
                        v-model="form.user_phone2"
                        type="text"
                        optional
                        placeholder="Opcional"/>
        </b-form-group>
        <b-form-checkbox id="same_address" v-model="same_address.status" value="true" unchecked-value="false" plain name="Endereço de cobrança" class="w-100 mx-md-5">Endereço da cobrança é o mesmo do usuário</b-form-checkbox>
        <b-form-group id="interesse-do-usuario"
                      label="Área de interesse:"
                      label-for="interesse">
          <b-form-input id="user_interest"
                        v-model="form.fields_of_interest"
                        type="text"
                        required
                        placeholder="Quais seus campos de interesse?"/>
        </b-form-group>
      </b-card>
      <b-card v-if="!same_address.status" class="my-3">
        <b-form-group id="cep-da-cobrança"
                      label="CEP da cobrança:"
                      label-for="CEP">
          <b-form-input id="user_CEP"
                        v-model="billing.CEP"
                        type="text"
                        optional
                        placeholder="CEP da cobrança"/>
        </b-form-group>
        <b-form-group id="rua-da-cobrança"
                      label="Rua:"
                      label-for="rua">
          <b-form-input id="billing_street"
                        v-model="billing.street"
                        type="text"
                        optional
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="numero-da-cobrança"
                      label="Numero:"
                      label-for="numero">
          <b-form-input id="billing_number"
                        v-model="billing.number"
                        type="text"
                        optional
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="cidade-da-cobrança"
                      label="Cidade:"
                      label-for="cidade">
          <b-form-input id="billing_city"
                        v-model="billing.city"
                        type="text"
                        optional
                        placeholder="Ex: São Paulo"/>
        </b-form-group>
        <b-form-select v-model="billing.state" :options="states" class="my-3">
          <template slot="first">
            <!-- this slot appears above the options from 'options' prop -->
            <option :value="null" disabled>Estado</option>
          </template>
        </b-form-select>
      </b-card>
      <b-card class="my-3">
        <strong> Responsabilidade </strong>
        <p>
          A responsabilidade pelas informações enviadas será exclusiva do usuário, não cabendo aos administradores do sistema fazer questionamentos quanto à veracidade das informações e das fontes usadas pelo interessado.
          Ao realizar o cadastro, o usuário se compromete a:
          <ol>
            <li> atualizar seu cadastro quando necessário; </li>
            <li> tomar conhecimento e seguir as regras de utilização específicas de cada Central e equipamento; </li>
            <li> agradecer às Centrais e aos Laboratórios em publicações quando houver contribuição de equipamentos multiusuários. </li>
          </ol>

          A responsabilidade quanto a questões legais e ressarcimento de ônus gerados pelas solicitações de serviços serão de única e exclusiva responsabilidade do usuário.
          A equipe de gerenciamento do USP Multi reserva o direito de terminar a qualquer momento a conta do usuário e eliminar seus dados caso detecte uso que viole os termos aqui colocados ou lei aplicável. </p>
      </b-card>
      <b-card class="my-3">
        <div class="pt-3 titles-container">
          <p class="form-title text-center font-weight-bold">
            Dados do sistema
          </p>
          <p class="form-subtitle text-center font-weight-light">
            Informações para login no sistema
          </p>
        </div>
        <b-form-group id="email"
                      label="Email:"
                      label-for="email">
          <b-form-input id="email"
                        v-model="form.user_email"
                        type="text"
                        required
                        placeholder=""/>
        </b-form-group>
        <b-form-group id="password"
                      label="Senha:"
                      label-for="password">
          <b-form-input id="pass"
                        v-model="form.password"
                        type="password"
                        optional
                        placeholder=""/>
        </b-form-group>
      </b-card>
      <b-row>
        <div v-if="submitError">
          <b-alert show dismissible variant="danger" @dismissed="dismissError">
            {{ errorMessage }}
          </b-alert>
        </div>
        <b-col sm="12" md="4" offset-md="8">
          <b-button class="btn-block" type="submit">Enviar</b-button>
        </b-col>
      </b-row>
    </b-form>
  </div>
</template>

<script>
export default {
  data() {
    return {
      errorMessage: null,
      submitError: false,
      units: ["Unidade 1", "Unidade 2", "Unidade 3"],
      workplaces: ["Empresa", "Instituição de Ensino Superior", "Outro"],
      bond_options: [
        "Graduando",
        "Graduando realizando Projeto de Iniciação Científica e Tecnológica",
        "Mestrando",
        "Doutorando",
        "Pós-Doutorando",
        "Pesquisador",
        "Professor",
        "Técnico de Laboratório",
        "Outro"
      ],
      gender_options: ["Masculino", "Feminino"],
      address: {
        street: null,
        number: null
      },
      same_address: {
        status: true
      },
      billing: {
        street: null,
        number: null,
        city: null,
        state: null
      },
      states: [
        "AC",
        "AL",
        "AM",
        "AP",
        "BA",
        "CE",
        "DF",
        "ES",
        "GO",
        "MA",
        "MT",
        "MS",
        "MG",
        "PA",
        "PB",
        "PR",
        "PE",
        "PI",
        "RJ",
        "RN",
        "RO",
        "RS",
        "RR",
        "SC",
        "SE",
        "SP",
        "TO"
      ],
      form: {
        is_USP_user: false,
        workplace: null,
        USP_bond_options: null,
        user_name: null,
        user_CPF: null,
        is_person: true,
        birth_date: null,
        gender: null,
        user_id: null,
        company_id: null,
        company_ie: null,
        company_im: null,
        user_CEP: null,
        user_address: null,
        user_city: null,
        user_state: null,
        billing_address: null,
        user_phone: null,
        user_phone2: null,
        user_email: null,
        password: null,
        fields_of_interest: null
      },
      show: true
    };
  },
  methods: {
    async onSubmit(evt) {
      evt.preventDefault();
      this.form.user_address =
        this.address.street +
        ", " +
        this.address.number +
        ", " +
        this.form.user_city +
        ", " +
        this.form.user_state;
      if (this.same_address.status)
        this.form.billing_address = this.form.user_address;
      else {
        this.form.billing_address =
          this.billing.street +
          ", " +
          this.billing.number +
          ", " +
          this.billing.city +
          ", " +
          this.billing.state;
      }
      try {
        await this.$axios.$post("user/", this.form);
        this.$router.push("/");
      } catch (e) {
        this.errorMessage = e.response.data.message;
      }
      //alert(JSON.stringify(this.form));
    },
    dismissError() {
      this.submitError = false;
    },
    dismissSucess() {
      this.submitSucess = false;
    }
  }
};
</script>


<style>
.form-title {
  --azul-claro-usp: #64c4d2;
  --azul-escuro-usp: #1094ab;
  font-size: 20px;
}

.form-subtitle {
  font-size: 15px;
}

.section-title {
  font-size: 30px;
}

.section-separator {
  border: 1px solid;
}

.btn-block {
  margin-top: 1em;
  margin-bottom: 1em;
  background-color: #fcb421;
}

.btn-block:hover {
  background-color: #ecbb5b;
}

.form-check-description {
  margin: 0.2em;
}
</style>
